/***********************************************************************************************************************
 *
 * SolidBlue - open source safe data
 * Copyright (C) 2011-2012 by Tidalwave s.a.s. (http://tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://solidblue.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/solidblue-src
 *
 **********************************************************************************************************************/
package it.tidalwave.actor.spi;

import javax.annotation.Nonnull;
import lombok.Getter;
import lombok.RequiredArgsConstructor;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
@RequiredArgsConstructor
/* package */ class ActorActivatorStats implements ActorActivatorStatsMBean
  {
    @Nonnull
    private final ActorActivator activator;
    
    @Getter
    private int pendingMessageCount;
    
    @Getter
    private int invocationCount;
    
    @Getter
    private int succesfulInvocationCount;
    
    @Getter
    private int invocationErrorCount;
    
    @Override
    public int getPoolSize()
      {
        return activator.poolSize;
      }

    public void changePendingMessageCount (final int delta)
      {
        pendingMessageCount += delta;
      }

    public void incrementInvocationCount() 
      {
        invocationCount++;
      }

    public void incrementInvocationErrorCount()
      {
        invocationErrorCount++;
      }

    public void incrementSuccessfulInvocationCount() 
      {
        succesfulInvocationCount++;
      }
  }
